<?php


	function delete_articles($articles_ids)
	{
		global $db, $table_prefix;

		if (strlen($articles_ids)) {
			// delete articles from following tables: articles, articles_assigned, articles_related, articles_images, articles_reviews
			$db->query("DELETE FROM " . $table_prefix . "articles_assigned WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")");
			$db->query("DELETE FROM " . $table_prefix . "articles_related WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")");
			$db->query("DELETE FROM " . $table_prefix . "articles_items_related WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")");
			$db->query("DELETE FROM " . $table_prefix . "articles_images WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")");
			$db->query("DELETE FROM " . $table_prefix . "articles_reviews WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")"); 
			$db->query("DELETE FROM " . $table_prefix . "articles WHERE article_id IN (" . $db->tosql($articles_ids, TEXT, false) . ")");
		}

	}

	function articles_import_rss($is_remote_rss, $remote_rss_url, $remote_rss_date_updated, $remote_rss_refresh_rate, $remote_rss_ttl)
	{
		global $db, $table_prefix, $category_id;

		$current_ts = va_timestamp();

		if ($remote_rss_refresh_rate) {
			$refresh_rate = $remote_rss_refresh_rate;
		} else if ($remote_rss_ttl) {
			$refresh_rate = $remote_rss_ttl;
		} else {
			$refresh_rate = 10;
		}
		
		$refresh_ts = ($refresh_rate * 60);
		if (is_array($remote_rss_date_updated)) {
			$refresh_ts += va_timestamp($remote_rss_date_updated);
		}

		if ($refresh_ts > $current_ts) {
			return false;
		}
  
		$article_order = 1;
		$feeds = '';

		$ch = curl_init();
		if ($ch){
			curl_setopt($ch, CURLOPT_URL, $remote_rss_url);
			// if use proxy server
			//curl_setopt($ch, CURLOPT_PROXY, "proxy_server:port");
			//curl_setopt($ch, CURLOPT_PROXYUSERPWD, "login:password");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			set_curl_options($ch,1);

			$feeds = curl_exec($ch);
			curl_close($ch);
		} else {
			$feeds = false;
		}

		if ($feeds) {
	  
			if ($remote_rss_url && strlen($feeds)) {
				$feeds = trim($feeds);
				if (strlen ($feeds)) {
					$sql = "SELECT * FROM " . $table_prefix."articles_assigned WHERE category_id = " . $db->tosql($category_id, INTEGER, true, false);
					$db->query($sql);
					$articles_ids = "";
					if ($db->next_record()){
						$articles_ids = $db->f("article_id");
						do {
							$articles_ids .= "," . $db->f("article_id");
						} while ($db->next_record());
					}
					delete_articles($articles_ids);
					if (strpos($feeds,"<ttl>") && strpos($feeds,"<ttl>") < strpos($feeds,"<item>")){
						$ttl = substr($feeds, strpos($feeds, "<ttl>")+strlen("<ttl>"), strpos($feeds, "</ttl>")-strlen("<ttl>")-strpos($feeds, "<ttl>"));
						$sql = "UPDATE " . $table_prefix . "articles_categories SET remote_rss_date_updated=" . $db->tosql($current_ts, DATETIME) . ", remote_rss_ttl=" . $db->tosql($ttl,INTEGER) . " WHERE category_id=" . $db->tosql($category_id, INTEGER, true, false);
					} else {
						$sql = "UPDATE " . $table_prefix . "articles_categories SET remote_rss_date_updated=" . $db->tosql($current_ts, DATETIME) . ", remote_rss_ttl=NULL WHERE category_id=" . $db->tosql($category_id, INTEGER, true, false);
					}
					$db->query($sql);
	  
					$index = 0;
					$feeds = substr($feeds, strpos($feeds, "<item>"));
	  
					while (strpos($feeds, "</item>")) {
						$aryItems[$index]['title'] = substr($feeds, strpos($feeds, "<title>")+strlen("<title>"), strpos($feeds, "</title>")-strlen("<title>")-strpos($feeds, "<title>"));
						$aryItems[$index]['link'] = substr($feeds, strpos($feeds, "<link>")+strlen("<link>"), strpos($feeds, "</link>")-strlen("<link>")-strpos($feeds, "<link>"));
						$aryItems[$index]['description'] = substr($feeds, strpos($feeds, "<description>")+strlen("<description>"), strpos($feeds, "</description>")-strlen("<description>")-strpos($feeds, "<description>"));
						if (strpos($feeds,"<fulltext>")) {
							if (strpos($feeds,"<fulltext>") < strpos($feeds,"<pubDate>")){
								$aryItems[$index]['fulltext'] = substr($feeds, strpos($feeds, "<fulltext>")+strlen("<fulltext>"), strpos($feeds, "</fulltext>")-strlen("<fulltext>")-strpos($feeds, "<fulltext>"));
							} else {
								$aryItems[$index]['fulltext'] = '';
							}
						} else {
							$aryItems[$index]['fulltext'] = '';
						}
						$aryItems[$index]['pubDate'] = substr($feeds, strpos($feeds, "<pubDate>")+strlen("<pubDate>"), strpos($feeds, "</pubDate>")-strlen("<pubDate>")-strpos($feeds, "<pubDate>"));
						$aryItems[$index]['description'] = import_rss_clean($aryItems[$index]['description']);
						$aryItems[$index]['fulltext'] = import_rss_clean($aryItems[$index]['fulltext']);
						$aryItems[$index]['link'] = import_rss_clean($aryItems[$index]['link']);
						$aryItems[$index]['pubDate'] = import_rss_clean($aryItems[$index]['pubDate']);
						$aryItems[$index]['title'] = import_rss_clean($aryItems[$index]['title']);
						if ( substr_count($aryItems[$index]['description'], "<img") > 1 || substr_count($aryItems[$index]['description'], "<img") == 0) {
							$aryItems[$index]['description'] = strip_tags($aryItems[$index]['description']);
							$aryItems[$index]['image'] = '';
							$aryItems[$index]['alt'] = '';
						} else {
							$image = $aryItems[$index]['description'];
							$image = substr($image, strpos($image, "<img ")+4);
							$img = preg_match("/src\=\"(.*)\"{1}/i", $image, $images);
							$img = preg_replace("/src\=\"/i", "", $images[0]);
							$img = preg_replace("/\".*/i", "", $img);
							if (strpos($image,"alt=\"")){
								$alt = preg_replace("/.*alt\=\"/i", "", $image);
								$alt = preg_replace("/\".*/i", "", $alt);
							} else {
								$alt = "";
							}
							$aryItems[$index]['description'] = strip_tags($aryItems[$index]['description']);
							$aryItems[$index]['image'] = $img;
							$aryItems[$index]['alt'] = $alt;
						}
						$index++;
						$feeds = substr($feeds, strpos($feeds, "</item>") + strlen("</item>"));
					}
	  
					for ($i=0;$i<$index;$i++) {
						$db->query("SELECT MAX(article_id) FROM " . $table_prefix . "articles");
						$db->next_record();
						$article_id = $db->f(0) + 1;
	  
						$sql = "INSERT INTO " . $table_prefix . "articles (friendly_url, article_id, article_order, article_date, article_title, date_added, short_description, full_description, status_id, is_remote_rss, details_remote_url, image_small, image_small_alt) ";
						$sql .= "VALUES ('',";
						$sql .= $db->tosql($article_id, INTEGER) . ",";
						$sql .= $db->tosql($article_order, INTEGER) . ",";
						$sql .= $db->tosql(strtotime($aryItems[$i]['pubDate']), DATETIME) . ",";
						$sql .= $db->tosql($aryItems[$i]['title'], TEXT) . ",";
						$sql .= $db->tosql($current_ts, DATETIME) . ",";
						$sql .= $db->tosql($aryItems[$i]['description'], TEXT) . ",";
						$sql .= $db->tosql($aryItems[$i]['fulltext'], TEXT) . ",";
						$sql .= "1,1,";
						$sql .= $db->tosql($aryItems[$i]['link'], TEXT) . ",";
						$sql .= $db->tosql($aryItems[$i]['image'], TEXT, true, false) . ",";
						$sql .= $db->tosql($aryItems[$i]['alt'], TEXT, true, false) . ")";
						$db->query($sql);
	  
						$sql  = " INSERT INTO " . $table_prefix . "articles_assigned (article_id, category_id) VALUES (";
						$sql .= $db->tosql($article_id, INTEGER) . ",";
						$sql .= $db->tosql($category_id, INTEGER) . ")";
						$db->query($sql);
					}
				}
			} else {
				return false;
			}
	
			return $index;
		} else {
			return false;
		}
	}
	
	function import_rss_clean($string){
		$string = preg_replace("/\<\!\[CDATA\[/", "", $string);
		$string = preg_replace("/\]\]\>/", "", $string);
		$string = preg_replace("/\&lt;/", "<", $string);
		$string = preg_replace("/\&gt;/", ">", $string);
		return $string;
	}

?>