<?php



/*
 * iDEAL (www.ing-ideal.nl)
 */

	function unhtmlentities($string)
	{
	    $trans_tbl = get_html_translation_table(HTML_ENTITIES);
	    $trans_tbl = array_flip($trans_tbl);
	    
	    return strtr($string, $trans_tbl);
	}

    function stripsimbls( $message ) 
    {
        $message = str_replace( " ", "", $message );
        $message = str_replace( "\t", "", $message );
        $message = str_replace( "\n", "", $message );
        
        return $message;
    }

    function createCertFingerprint($filename) 
    {
        $fp = fopen($filename, "r");

        if (!$fp) {
            return false;
        }
        $cert = fread($fp, 8192);
        fclose($fp);

        $data = openssl_x509_read($cert);

        if (!openssl_x509_export($data, $data)) {

            return false;
        }

        $data = str_replace("-----BEGIN CERTIFICATE-----", "", $data);
        $data = str_replace("-----END CERTIFICATE-----", "", $data);
        $data = base64_decode($data);
        $fingerprint = sha1($data);
        $fingerprint = strtoupper($fingerprint);

        return $fingerprint;

    }

    function signMessage($priv_keyfile, $key_pass, $data) 
    {
        $fp = fopen($priv_keyfile , "r");
        $priv_key = fread($fp, 8192);
        fclose($fp);
        $pkeyid = openssl_get_privatekey($priv_key, $key_pass);
        openssl_sign($data, $signature, $pkeyid);
        openssl_free_key($pkeyid);

        return $signature;

    }

    function PostToHost($url, $timeout, $data_to_send) 
    {
    	$idx = strrpos($url, ":");
    	$host = substr($url, 0, $idx);
    	$url = substr($url, $idx + 1);
    	$idx = strpos($url, "/");
    	$port = substr($url, 0, $idx);
    	$path = substr($url, $idx);
    	if (!strlen($port)){
	    	$idx = strrpos($host, ":");
	    	$protocol = substr($host, 0, $idx);
			switch ($protocol) {
				case 'ssl':
					$port = 443;
					break;
				case 'https':
					$port = 443;
					break;
				case 'http':
					$port = 80;
					break;
			}
		}
        $fsp = fsockopen($host, $port, $errno, $errstr, $timeout);
        if ($fsp) {
            fputs($fsp, "POST $path HTTP/1.0\r\n");
            fputs($fsp, "Accept: text/html\r\n");
            fputs($fsp, "Accept: charset=ISO-8859-1\r\n");
            fputs($fsp, "Content-Length:".strlen($data_to_send)."\r\n");
            fputs($fsp, "Content-Type: text/html; charset=ISO-8859-1\r\n\r\n");
            fputs($fsp, $data_to_send, strlen($data_to_send));

			$res="";
            while(!feof($fsp)) {
                $res .= fgets($fsp, 128);
            }
            fclose($fsp);
		    return $res;
        }
        else {
            return "Error: " . $errstr;
        }
    }

	$is_admin_path = true;
	$root_folder_path = "../";

	include_once($root_folder_path ."includes/common.php");
	include_once($root_folder_path ."includes/order_items.php");
	include_once($root_folder_path ."includes/date_functions.php");
    include_once($root_folder_path ."messages/".$language_code."/cart_messages.php");
	include_once($root_folder_path ."includes/parameters.php");

	$vc = get_session("session_vc");
	$order_id = get_session("session_order_id");

	$order_errors = check_order($order_id, $vc);
	if ($order_errors) 
	{
		echo $order_errors;
		exit;
	} 
	else 
	{
		$variables = array();
		$variables["site_url"] = $settings["site_url"];
		$variables["order_id"] = $order_id;
		$sql  = " SELECT * FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			// payment information
			$payment_id = $db->f("payment_id");

			$variables["user_id"] = $db->f("user_id");
			$variables["total_quantity"] = $db->f("total_quantity");
			// email variables
			$variables["email"] = $db->f("email");
			$delivery_email["delivery_email"] = $db->f("delivery_email");

			for ($i = 0; $i < sizeof($parameters); $i++) {
				$variables[$parameters[$i]] = $db->f($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $db->f("delivery_" . $parameters[$i]);
			}

			// shopping variables
			$variables["goods_total"] = $db->f("goods_total");
			$variables["total_discount"] = $db->f("total_discount");
			$variables["goods_with_discount"] = $variables["goods_total"] - $variables["total_discount"];
			$variables["shipping_cost"] = $db->f("shipping_cost");
			$variables["tax_percent"] = $db->f("tax_percent");
			$variables["tax_total"] = $db->f("tax_total");
			$variables["tax_name"] = $db->f("tax_name");
			$variables["order_total"] = $db->f("order_total");
			$variables["order_placed_date"] = $db->f("order_placed_date", DATETIME);

			$variables["name"] = $db->f("name");
			$variables["first_name"] = $db->f("first_name");
			$variables["last_name"] = $db->f("last_name");
			$variables["company_name"] = $db->f("company_name");
			$variables["address1"] = $db->f("address1");
			$variables["address2"] = $db->f("address2");
			$variables["city"] = $db->f("city");
			$variables["province"] = $db->f("province");
			$variables["zip"] = $db->f("zip");
			$variables["phone"] = $db->f("phone");
			$variables["daytime_phone"] = $db->f("daytime_phone");
			$variables["evening_phone"] = $db->f("evening_phone");
			$variables["cell_phone"] = $db->f("cell_phone");
			$variables["fax"] = $db->f("fax");
			$variables["state_code"] = $db->f("state_code");
			$variables["country_code"] = $db->f("country_code");
		}

		$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
		$variables["country"] = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT));
		$variables["delivery_state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["delivery_state_code"], TEXT));
		$variables["delivery_country"] = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT));
		if (strlen($variables["delivery_state_code"])) {
			$variables["delivery_state_code_or_province"] = $variables["delivery_state_code"];
			$variables["delivery_state_or_province"] = $variables["delivery_state"];
		} else {
			$variables["delivery_state_code_or_province"] = $variables["delivery_province"];
			$variables["delivery_state_or_province"] = $variables["delivery_province"];
		}

		if (strlen($payment_id)) {
			// get payment parameters
			$payment_params = array();
			$sql  = " SELECT parameter_name, parameter_type, parameter_source, not_passed ";
			$sql .= " FROM " . $table_prefix . "payment_parameters ";
			$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
			$db->query($sql);
			while ($db->next_record()) {
				$parameter_name = trim($db->f("parameter_name"));
				$parameter_source = trim($db->f("parameter_source"));
				$not_passed = trim($db->f("not_passed"));
				if (strtoupper($db->f("parameter_type")) == strtoupper('VARIABLE')) {
					if (preg_match_all("/\{(\w+)\}/is", $parameter_source, $matches)) {
						$parameter_value = $parameter_source;
						for($p = 0; $p < sizeof($matches[1]); $p++) {
							$l_source = strtolower($matches[1][$p]);
							if (isset($variables[$l_source])) {
								$parameter_value = str_replace("{".$l_source."}", $variables[$l_source], $parameter_value);
							}
						}
					} else if (isset($variables[$parameter_source])) {
						$parameter_value = $variables[$parameter_source];
					} else {
						$parameter_value = $parameter_source;
					}
				} else {
					$parameter_value = $parameter_source;
				}
				$payment_params[$parameter_name] = $parameter_value;
			}
		} else {
			// invalid data info
			exit;
		}

		$payment_parameter = array();
		$payment_parameter = $payment_params;
		$sql  = " SELECT order_total FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$order_total = $db->f("order_total")*100;
			$order_total = round($order_total,0);
		}
		if (isset($payment_parameter["Amount"])){
			$order_total=$payment_parameter["Amount"]*100;
			$order_total = round($order_total,0);
		}

		$timestamp = gmdate("Y") . "-" . gmdate("m") . "-" . gmdate("d") . "T" . gmdate("H") . ":" . gmdate("i") . ":" . gmdate("s") . ".000Z";
		$token = "";
		$tokenCode = "";

		$debug = (isset($payment_parameter["debug"])) ? $payment_parameter["debug"] : "";
		$cert_not_find = false;
		if (!file_exists($payment_parameter["Privatekey"])) {
			if ($debug) {
				echo "Can not find 'Privatekey'<br>\n";
			}
			$cert_not_find = true;
		}
		if (!file_exists($payment_parameter["Privatecert"])) {
			if ($debug) {
				echo "Can not find 'Privatecert'<br>\n";
			}
			$cert_not_find = true;
		}
		if (!file_exists($payment_parameter["Certificate0"])) {
			if ($debug) {
				echo "Can not find 'Certificate0'<br>\n";
			}
			$cert_not_find = true;
		}
		if ($cert_not_find) {
			if (!$debug) {
				echo "Some errors occurred while processing you request to iDEAL.<br>\n";
			}
			exit;
		}

		if ($payment_parameter["IssuerID"] == "") {
			$payment_parameter["IssuerID"] = get_param("issuer_id");
		}
		if ($payment_parameter["IssuerID"] == "") {
			if ("SHA1_RSA" == $payment_parameter["AuthenticationType"]) {
				$message = $timestamp . $payment_parameter["MerchantID"] . $payment_parameter["SubID"];
				$message = stripsimbls( $message );

				$token = createCertFingerprint($payment_parameter["Privatecert"]);

				$tokenCode = signMessage( $payment_parameter["Privatekey"], $payment_parameter["PrivatekeyPass"], $message );
				$tokenCode = base64_encode( $tokenCode );
			}
			$reqMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
				. "<DirectoryReq xmlns=\"http://www.idealdesk.com/Message\" version=\"1.1.0\">\n"
				. "<createDateTimeStamp>" . $timestamp . "</createDateTimeStamp>\n"
				. "<Merchant>\n"
				. "<merchantID>" . $payment_parameter["MerchantID"] . "</merchantID>\n"
				. "<subID>" . $payment_parameter["SubID"] . "</subID>\n"
				. "<authentication>" . $payment_parameter["AuthenticationType"] . "</authentication>\n"
				. "<token>" . $token . "</token>\n"
				. "<tokenCode>" . $tokenCode . "</tokenCode>\n"
				. "</Merchant>\n"
				. "</DirectoryReq>";

			$answer = PostToHost($payment_parameter["AcquirerURL"], $payment_parameter["AcquirerTimeout"], $reqMsg);

			$response_parameters = array();
			preg_match_all ("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $answer, $matches, PREG_SET_ORDER);
			for ($i = 0; $i < sizeof($matches); $i++) {
				if ($matches[$i][1]=="issuerID"){
					$response_parameters["IssuerID"][] = array($matches[$i][2],$matches[$i+1][2]);
				} else {
					$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
				}
			}
			if (isset($response_parameters["errorCode"])) {
				echo "errorCode - " . $response_parameters["errorCode"] . "<br>";
				echo "errorMessage - " . $response_parameters["errorMessage"] . "<br>";
				exit;
			}

			if (sizeof($response_parameters["IssuerID"])==1) {
				$payment_parameter["IssuerID"]=$response_parameters["IssuerID"][0][0];
			} else {
?>
<html>
<head>
<title>..: Select Issuer :..</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<body>

	<form action="ideal_process.php" method="post" name="OrderForm">
	<div align="center" style="font-family: tahoma, arial, sans-serif; color: navy; ">
	Please select Issuer:
	<select name="issuer_id">
<?php
				foreach ($response_parameters["IssuerID"] as $parameter_name => $parameter_value) {
					echo "<option  value=\"" . $response_parameters["IssuerID"][$parameter_name][0] . "\">"
						. $response_parameters["IssuerID"][$parameter_name][1];
				}
?>
	</select>
	<input type="submit" value="Continue" style="border: 1px solid gray; background-color: #e0e0e0; font-family: tahoma, arial, sans-serif; height: 20px; color: #333333; font-weight: bold;">
	</div>
	</form>

</body>
</html>
<?php
			exit;
			}
		}

        if ( "SHA1_RSA" == $payment_parameter["AuthenticationType"] ) {
			$message = $timestamp
				.$payment_parameter["IssuerID"]
				.$payment_parameter["MerchantID"]
				.$payment_parameter["SubID"]
				.$payment_parameter["MerchantReturnURL"]
				.$order_id
				.$order_total
				.$payment_parameter["Currency"]
				.$payment_parameter["Language"]
				.$payment_parameter["DESCRIPTION"]
				.$payment_parameter["EntranceCode"];
			$message = stripsimbls($message);

        	$token = createCertFingerprint($payment_parameter["Privatecert"]);

        	$tokenCode = signMessage( $payment_parameter["Privatekey"], $payment_parameter["PrivatekeyPass"], $message);
        	$tokenCode = base64_encode( $tokenCode );
		}
		$reqMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
                . "<AcquirerTrxReq xmlns=\"http://www.idealdesk.com/Message\" version=\"1.1.0\">\n"
                . "<createDateTimeStamp>" . $timestamp .  "</createDateTimeStamp>\n"
                . "<Issuer>" . "<issuerID>" . $payment_parameter["IssuerID"] . "</issuerID>\n"
                . "</Issuer>\n"
                . "<Merchant>" . "<merchantID>" . $payment_parameter["MerchantID"] . "</merchantID>\n"
                . "<subID>" . $payment_parameter["SubID"] . "</subID>\n"
                . "<authentication>" . $payment_parameter["AuthenticationType"] . "</authentication>\n"
                . "<token>" . $token . "</token>\n"
                . "<tokenCode>" . $tokenCode . "</tokenCode>\n"
                . "<merchantReturnURL>" . $payment_parameter["MerchantReturnURL"] . "</merchantReturnURL>\n"
                . "</Merchant>\n"
                . "<Transaction>" . "<purchaseID>" . $order_id . "</purchaseID>\n"
                . "<amount>" . $order_total . "</amount>\n"
                . "<currency>" . $payment_parameter["Currency"] . "</currency>\n"
                . "<expirationPeriod>" . $payment_parameter["ExpirationPeriod"] . "</expirationPeriod>\n"
                . "<language>" . $payment_parameter["Language"] . "</language>\n"
                . "<description>" . $payment_parameter["DESCRIPTION"] . "</description>\n"
                . "<entranceCode>" . $payment_parameter["EntranceCode"] . "</entranceCode>\n"
                . "</Transaction>" . "</AcquirerTrxReq>";
		$answer = PostToHost($payment_parameter["AcquirerURL"], $payment_parameter["AcquirerTimeout"], $reqMsg);
		
		$response_parameters = array();
		preg_match_all("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $answer, $matches, PREG_SET_ORDER);
		for ($i = 0; $i < sizeof($matches); $i++) {
			$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
		}
		if (isset($response_parameters["errorCode"])) {
			echo "errorCode - " . $response_parameters["errorCode"] . "<br>";
			echo "errorMessage - " . $response_parameters["errorMessage"] . "<br>";
			exit;
		}
		if ( isset($response_parameters["purchaseID"]) && $order_id == $response_parameters["purchaseID"]) {
			$sql  = " UPDATE " . $table_prefix . "orders ";
			$sql .= " SET transaction_id=" . $db->tosql($response_parameters["transactionID"], TEXT) ;
			$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER) ;
			$db->query($sql);
			header("Location: " . unhtmlentities($response_parameters["issuerAuthenticationURL"]));
		}
	}
	
?>